#pragma region License
/*
License (OLC-3)
~~~~~~~~~~~~~~~

Copyright 2018 - 2023 OneLoneCoder.com

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

1. Redistributions or derivations of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

2. Redistributions or derivative works in binary form must reproduce the above
copyright notice. This list of conditions and the following	disclaimer must be
reproduced in the documentation and/or other materials provided with the distribution.

3. Neither the name of the copyright holder nor the names of its contributors may
be used to endorse or promote products derived from this software without specific
prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS	"AS IS" AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
SHALL THE COPYRIGHT	HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL,	SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT	(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.
*/
#pragma endregion
#include "util.h"
#include "olcPixelGameEngine.h"

float util::random(float range){
	return float(rand())/RAND_MAX*range;
}

vf2d util::pointTo(vf2d posFrom,vf2d posTo){
	return geom2d::line(posFrom,posTo).vector().norm();
}

float util::angleTo(vf2d posFrom,vf2d posTo){
	return geom2d::line<float>(posFrom,posTo).vector().polar().y;
}

float util::degToRad(float deg){
	return deg*(PI/180);
}

float util::radToDeg(float rad){
	return rad*57.2957795130823208767f;
}

float util::lerp(float n1,float n2,double t){
	return float(n1*(1-t)+n2*t);
}

std::string util::timerStr(float time){
	int seconds=int(time);
	int hours=seconds/3600;
	int minutes=seconds/60;

	std::string timeStr="";
	if(hours>0){
		if(hours<10)timeStr+="0";
		timeStr+=std::to_string(hours)+":";
	}

	if(minutes%60<10)timeStr+="0";
	timeStr+=std::to_string(minutes%60)+":";

	if(seconds%60<10)timeStr+="0";
	timeStr+=std::to_string(seconds%60);

	return timeStr;
}

std::string util::WrapText(PixelGameEngine*pge,std::string str,int width,bool proportional,vd2d scale){
	std::string newStr;
	while (true) {
		std::string word;
		if (str.find(" ")==std::string::npos) {
			word=str;
		} else {
			word = str.substr(0,str.find(" "));
		}
		vi2d newSize = vd2d(proportional?pge->GetTextSizeProp(newStr+(newStr.size()>0?" ":"")+word):pge->GetTextSize(newStr+(newStr.size()>0?" ":"")+word))*scale;
		if (newSize.x>width) {
			newStr+="\n"+word;
		} else {
			newStr+=(newStr.size()>0?" ":"")+word;
		}
		if (str.find(" ")==std::string::npos) {
			break;
		} else {
			str.erase(0,str.find(" ")+1);
		}
	}
	return newStr;
}